<template>
	<a-drawer
		:title="formData.id ? '编辑库位管理' : '增加库位管理'"
		:width="600"
		:visible="visible"
		:destroy-on-close="true"
		:footer-style="{ textAlign: 'right' }"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-form-item label="企业客户：" name="depotId" v-if="!formData.depotId">
				<a-select v-model:value="formData.depotId" placeholder="请选择企业客户" :options="depotIdOptions"/>
			</a-form-item>
			<a-form-item label="库位：" name="shedName">
				<a-input v-model:value="formData.shedName" placeholder="请输入库位" allow-clear/>
			</a-form-item>
			<a-form-item label="描述：" name="remark">
				<a-textarea v-model:value="formData.remark" placeholder="请输入描述" :auto-size="{ minRows: 8, maxRows: 20 }" allow-clear/>
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</a-drawer>
</template>

<script setup name="depotGrainShedForm">
import tool from '@/utils/tool'
import {cloneDeep} from 'lodash-es'
import {required} from '@/utils/formRules'
import depotGrainShedApi from '@/api/biz/depotGrainShedApi'
import dictOptionsApi from "@/api/biz/dictOptionsApi";
import {message} from "ant-design-vue";
// 抽屉状态
const visible = ref(false)
const emit = defineEmits({successful: null})
const formRef = ref()
// 表单数据
const formData = ref({})
const submitLoading = ref(false)
const depotIdOptions = ref([])

// 打开抽屉
const onOpen = (record) => {
	visible.value = true
	if (record) {
		let recordData = cloneDeep(record)
		formData.value = Object.assign({}, recordData)
	} else {
		dictOptionsApi.options(Object.assign('', {'dictValue': '粮库'})).then((data) => {
			depotIdOptions.value = data
		})
	}
}
// 关闭抽屉
const onClose = () => {
	formRef.value.resetFields()
	formData.value = {}
	visible.value = false
}
// 默认要校验的
const formRules = {
	depotId: [required('请输入项目编码')],
	shedName: [required('请输入库位')],
	remark: [required('请输入描述')],
}
// 验证并提交数据
const onSubmit = () => {
	formRef.value
		.validate()
		.then(() => {
			if (formData.value.shedName.length > 32) {
				message.warning('库位长度' + formData.value.shedName.length + '，不能超过32')
				return false
			}
			if (formData.value.remark.length > 255) {
				message.warning('描述长度' + formData.value.remark.length + '，不能超过255')
				return false
			}
			submitLoading.value = true
			const formDataParam = cloneDeep(formData.value)
			depotGrainShedApi
				.depotGrainShedSubmitForm(formDataParam, !formDataParam.id)
				.then(() => {
					onClose()
					emit('successful')
				})
				.finally(() => {
					submitLoading.value = false
				})
		})
}
// 抛出函数
defineExpose({
	onOpen
})
</script>
